var $ = jQuery;
$(function() {
	
	// Шаблон мероприятия
	function GetSubModuleTmp(){
		return '\
		<div class="subModule">\
			<div class="name">\
				<input type="text" class="inputName SubmoduleName" value="" placeholder="Наименование мероприятия">\
			</div>\
			<div class="currentControl"><input type="text" class="inputCredit inputCurrentControl" value="0"></div>\
			<div class="landmarkControl"><input type="text" class="inputCredit inputLandmarkControl" value="0"></div>\
			<div class="actions">\
				<div class="deleteSubModule icon delete"></div>\
				<div class="downSubModule icon down"></div>\
				<div class="upSubModule icon up"></div>\
			</div>\
		</div>\
		';
	}

	// Шаблон модуля
	function GetModuleTmp() {
		return '\
		<div class="moduleGroup">\
			<div class="moduleHead">\
				<div class="name">\
					<input type="text" class="inputName ModuleName" value="" placeholder="Наименование модуля">\
				</div>\
				<div class="currentControl">0</div>\
				<div class="landmarkControl">0</div>\
				<div class="actions">\
					<div class="deleteModule icon delete"></div>\
					<div class="downModule icon down"></div>\
					<div class="upModule icon up"></div>\
				</div>\
			</div>\
			<div class="subModules">\
			'+ GetSubModuleTmp() +'\
			</div>\
			<button class="addSubModule">Добавить мероприятие</button>\
		</div>'
	};

	// Подсчет текущего контроля
	function CountCurrentControl(subModulesDiv){
		var maxCredits = 0;
		$('input.inputCurrentControl', subModulesDiv).each(function(){
			var credit = parseInt($(this).val());
			maxCredits = maxCredits + ((isNum(credit)) ? credit : 0);
		});
		subModulesDiv.prev().children('div.currentControl').text(maxCredits);
	}
	// Подсчет рубежного контроля
	function CountLandmarkControl(subModulesDiv){
		var maxCredits = 0;
		$('input.inputLandmarkControl', subModulesDiv).each(function(){
			var credit = parseInt($(this).val());
			maxCredits = maxCredits + ((isNum(credit)) ? credit : 0); 
		});
		subModulesDiv.prev().children('div.landmarkControl').text(maxCredits);
	}
	
	// Изменение типа подмодуля
	function ChangeSubmoduleControlType(ID, ControlType){
		$.post(
			URLdir + 'handler/map/ChangeSubmoduleControlType',
			{
				'SubmoduleID': ID,
				'ControlType': ControlType
			},
			function(data){
				data = $.parseJSON(data);
				//if(data.success === true)
				//	EventInspector_ShowMsg('Форма контроля изменена', 'success');
				//else EventInspector_ShowMsg('Ошибка при изменение формы контроля', 'error');
			}
		);
	}
	
	// Изменение макс. балла подмодуля
	function ChangeSubmoduleMaxRate(thisObj, ID, NewMaxRate) {
		$.post(
			URLdir + 'handler/map/ChangeSubmoduleMaxRate',
			{
				'SubmoduleID': ID,
				'MaxRate': NewMaxRate
			},
			function(data){
				data = $.parseJSON(data);
				if(data.success === true)
					EventInspector_ShowMsg('Max балл мероприятия изменен', 'success');
				else EventInspector_ShowMsg('Ошибка при изменении max балла', 'error');
				thisObj.removeAttr('disabled');
			}
		);
	}
	
	// Установить новый max балл
	function SetNewRateAndControl(thisObj, OldMaxRate) {
		// DIV с мероприятиями для данного модуля
		var subModulesDiv = thisObj.parent().parent().parent();
		// ID мероприятия
		var ID = thisObj.parent().parent().attr('id');
		var NewMaxRate = 0;
		if (thisObj.val().length > 0 )
			NewMaxRate = parseInt(thisObj.val());
		
		// Ограничение 100 баллов
		var MaxSumRate = 100;
		if ($('div.ExamModule').first().length > 0) MaxSumRate = 60;
		
		var currentControl = 0;
		$('div.moduleHead').children('div.currentControl').each(function(){
			currentControl += parseInt($(this).text());
		});
		
		var landmarkControl = 0;
		$('div.moduleHead').children('div.landmarkControl').each(function(){
			landmarkControl += parseInt($(this).text());
		});
		
		var subtract = 0;
		if (thisObj.parent().attr('class').indexOf('landmarkControl') + 1 > 0)
			subtract = parseInt(thisObj.parent().siblings('.currentControl').children().val());
		if (thisObj.parent().attr('class').indexOf('currentControl') + 1 > 0)
			subtract = parseInt(thisObj.parent().siblings('.landmarkControl').children().val());
			
		if (currentControl + landmarkControl + NewMaxRate - subtract - OldMaxRate > MaxSumRate) {
			if (NewMaxRate == 0)
				thisObj.val('0');
			else {
				EventInspector_ShowMsg('Сумма баллов превышает максимум', 'error');
				thisObj.val(OldMaxRate);
				thisObj.removeAttr('disabled')
				return 0;
			}
		}
		
		// Меняем max балл
		if (NewMaxRate != OldMaxRate) {
			ChangeSubmoduleMaxRate(thisObj, ID, NewMaxRate);
			
			// Счетчик баллов
			var RateIndicarot = currentControl + landmarkControl + NewMaxRate - subtract - OldMaxRate;
			if ($('div.ExamModule').length > 0) RateIndicarot += 40;
			$('div.RateIndicatorDIV span.RateIndicator').html(RateIndicarot);
			
			// Меняем тип
			ControlType = 'CurrentControl'; // По-умолчанию 
			if ((thisObj.parent().attr('class')).indexOf('landmarkControl') + 1 > 0)
				ControlType = 'LandmarkControl';	
			if (NewMaxRate > 0)
				ChangeSubmoduleControlType(ID, ControlType);
			
			if (ControlType == 'CurrentControl')
				thisObj.parent().parent().find('div.landmarkControl').children('input.inputLandmarkControl').val('0');
				
			if (ControlType == 'LandmarkControl')
				thisObj.parent().parent().find('div.currentControl').children('input.inputCurrentControl').val('0');
		} else thisObj.removeAttr('disabled');
		
		// Подсчет текущего и рубежного контроля после изменений
		CountCurrentControl(subModulesDiv);
		CountLandmarkControl(subModulesDiv);
	}
	
	// Поменять местами два модуля
	function SwapModuleOrder(ModuleID1, ModuleID2) {
		$.post(
			URLdir + 'handler/map/SwapModuleOrder',
			{
				'ModuleID1': ModuleID1,
				'ModuleID2': ModuleID2
			},
			function(data){
				data = $.parseJSON(data);
				if(data.success === true)
					EventInspector_ShowMsg('Модули поменяли порядок', 'success');
				else EventInspector_ShowMsg('Ошибка при изменении порядка модулей', 'error');
			}
		);
	}
	
	// Поменять местами два мероприятия
	function SwapSubmoduleOrder(SubmoduleID1, SubmoduleID2) {
		$.post(
			URLdir + 'handler/map/SwapSubmoduleOrder',
			{
				'SubmoduleID1': SubmoduleID1,
				'SubmoduleID2': SubmoduleID2
			},
			function(data){
				data = $.parseJSON(data);
				if(data.success === true)
					EventInspector_ShowMsg('Мероприятия поменяли порядок', 'success');
				else EventInspector_ShowMsg('Ошибка при изменении порядка мероприятий', 'error');
			}
		);
	}
	
//-------------------------------------------------------------------------------------------------------------------------------------------------
	
	// Переместить вверх МОДУЛЬ
    $(".moduleList").on('click', '.upModule', function(){
        var parentDIV = $(this).parent().parent().parent();
		var moduleGroupDiv = parentDIV.prev('div.moduleGroup');
		if (moduleGroupDiv.length > 0) {
			parentDIV.insertBefore(parentDIV.prev('.moduleGroup'));
			
			var ModuleID = parentDIV.attr('id');
			// Для того, который СТАЛ находится ниже
			var nextModuleID = parentDIV.next().attr('id');
			SwapModuleOrder(ModuleID, nextModuleID);
		}
    });
	
	// Переместить вниз МОДУЛЬ
    $(".moduleList").on('click', '.downModule', function(){
        var parentDIV = $(this).parent().parent().parent();
		var moduleGroupDiv = parentDIV.next('div.moduleGroup');
		if (moduleGroupDiv.length > 0) {
			parentDIV.insertAfter(moduleGroupDiv);
			
			var ModuleID = parentDIV.attr('id');
			// Для того, который СТАЛ находится выше
			var prevModuleID = parentDIV.prev().attr('id');
			SwapModuleOrder(ModuleID, prevModuleID);
		}
    });
	
	// Переместить вверх мероприятие
    $(".moduleList").on('click', '.upSubModule', function(){
        var parentDIV = $(this).parent().parent();
		var subModule = parentDIV.prev('div.subModule');
		if (subModule.length > 0) {
			parentDIV.insertBefore(parentDIV.prev());
			
			var SubmoduleID = parentDIV.attr('id');
			var nextSubmoduleID = parentDIV.next().attr('id');
			SwapSubmoduleOrder(SubmoduleID, nextSubmoduleID);
		}
    });
	
	// Переместить вниз мероприятие
    $(".moduleList").on('click', '.downSubModule', function(){
        var parentDIV = $(this).parent().parent();
		var subModule = parentDIV.next('div.subModule');
		if (subModule.length > 0) {
			parentDIV.insertAfter(subModule);
			
			var SubmoduleID = parentDIV.attr('id');
			var prevSubmoduleID = parentDIV.prev().attr('id');
			SwapSubmoduleOrder(SubmoduleID, prevSubmoduleID);
		}
    });
	
	// Добавить модуль
	$('.addModule').click(function(){
		var thisObj = $(this);
    	$(this).attr("disabled", true);
		var OrderNum = $('div.moduleGroup', 'div.moduleList').last().index('.moduleGroup') + 2;
		$.post(
			URLdir + 'handler/map/AddModule',
			{
				'DisciplineID': DisciplineID
			},
			function(data){
				data = $.parseJSON(data);
				if(data.success === true) {
					var ExamModule = $('div.ExamModule');
					var BonusModule = $('div.BonusModule');
					if (BonusModule.length > 0)
						$('div.BonusModule').before(GetModuleTmp());
					else {
						if (ExamModule.length > 0)
							$('div.ExamModule').before(GetModuleTmp());
						else
							$('div.moduleList').append(GetModuleTmp());
					}
						
					// К добавленному модулю добавляем ID
					var thisModuleDIV = $('div.moduleGroup').eq(OrderNum - 1);
					thisModuleDIV.attr('id', data.ModuleID);
					// К добавленному в модуль мероприятию добавляем ID
					thisModuleDIV.children('div.subModules').children('div.subModule').eq(0).attr('id', data.SubmoduleID);
					EventInspector_ShowMsg('Модуль добавлен', 'success');
				} else EventInspector_ShowMsg('Ошибка при добавлении модуля', 'error');
				thisObj.removeAttr('disabled');
			}
		);
		
		if ($('.empty').css('display') == 'block')
			$('.empty').css('display', 'none');
		
	});
	
	// Добавить мероприятие
	$('div.moduleList').on('click', 'button.addSubModule', function(){
		var thisObj = $(this);
    	$(this).attr("disabled", true);
		var ModuleID = $(this).parent().attr('id');
		var SubmodulesDIV = $(this).siblings('div.subModules');
		var OrderNum = SubmodulesDIV.children('div.subModule').last().index() + 2;
		$.post(
			URLdir + 'handler/map/AddSubmodule',
			{
				'ModuleID': ModuleID
			},
			function(data){
				data = $.parseJSON(data);
				if(data.success === true) {
					// К добавленному мероприятию добавляем ID
					SubmodulesDIV.append(GetSubModuleTmp());
					SubmodulesDIV.children('div.subModule').eq(OrderNum - 1).attr('id', data.SubmoduleID);
					EventInspector_ShowMsg('Мероприятие добавлено', 'success');
				} else EventInspector_ShowMsg('Ошибка при добавлении мероприятия', 'error');
				thisObj.removeAttr('disabled');
			}
		);
	});
	
	// Удалить модуль
	$('.moduleList').on('click', '.deleteModule', function(){
		$(this).parent().css('display', 'none');
		$(this).parent().parent().append('<div class="confirmDeleteDiv">Уверены? <span class="confirmDeleteModule">Да</span> <span class="cancel">Нет</span></div>');
	});
	
	// Подтверждение при удаление модуля
	$('.moduleList').on('click', '.confirmDeleteModule', function(){
		var thisObj = $(this);
		var subModulesDIV = $(this).parent().parent().next('div.subModules');
		var CurrentModuleOrder = $(this).parent().parent().parent().index() + 1;
		// Собираем в JSON строку ID мероприятий
		var JSONSubmodules = '[';
		$('div.subModule', subModulesDIV).each(function(){
			JSONSubmodules += $(this).attr('id') + ',';
		});
		JSONSubmodules = JSONSubmodules.substr(0, JSONSubmodules.length - 1);
		JSONSubmodules += ']';
		//
		// Собираем ID модулей, которые ниже для того, чтоб сменить их порадок на +1
		var AttrID = $(this).parent().parent().parent().nextAll().map(function(indx, element){
			return $(element).attr("id");
		});
		var ChangeOrderModulesID = '[' + AttrID.get() + ']';
		//
		$.post(
			URLdir + 'handler/map/DeleteModule',
			{
				'ModuleID': $(this).parent().parent().parent().attr('id'),
				'SubmodulesID': JSONSubmodules,
				'CurrentModuleOrder': CurrentModuleOrder,
				'ChangeOrderModulesID': ChangeOrderModulesID
			},
			function(data){
				data = $.parseJSON(data);
				if(data.success === true) {
					thisObj.parent().parent().parent().remove();
					
					var c = 0;
					$('div.moduleGroup')
						.children('div.moduleHead')
						.children('div.currentControl')
						.each(function(){
							c += parseInt($(this).text());
						});
						
					var l = 0;
					$('div.moduleGroup')
						.children('div.moduleHead')
						.children('div.landmarkControl')
						.each(function(){
							l += parseInt($(this).text());
						});
					
					var e = 0;
					if ($('div.ExamModule').length > 0) e = 40;
					
					$('span.RateIndicator').html(c + l + e);
						
					EventInspector_ShowMsg('Модуль удален', 'success');
				}
				else EventInspector_ShowMsg('Ошибка при удаление модуля', 'error');
			}
		);
	});
	
	// Удалить мероприятие
	$('.moduleList').on('click', '.deleteSubModule ', function(){
		$(this).parent().css('display', 'none');
		$(this).parent().parent().append('<div class="confirmDeleteDiv">Уверены? <span class="confirmDeleteSubModule">Да</span> <span class="cancel">Нет</span></div>');
	});
	
	// Подтверждение при удаление мероприятия
	$('.moduleList').on('click', '.confirmDeleteSubModule ', function(){
		var thisObj = $(this);
		var subModulesDiv = $(this).parent().parent().parent();
		var CurrentSubmoduleOrder = $(this).parent().parent().index() + 1;
		CountCurrentControl(subModulesDiv);
		CountLandmarkControl(subModulesDiv);
		// Собираем ID мероприятий, которые ниже для того, чтоб сменить их порадок на +1
		var AttrID = $(this).parent().parent().nextAll().map(function(indx, element){
			return $(element).attr("id");
		});
		var ChangeOrderSubmodulesID = '[' + AttrID.get() + ']';
		//
		$.post(
			URLdir + 'handler/map/DeleteSubmodule',
			{
				'SubmoduleID': $(this).parent().parent().attr('id'),
				'CurrentSubmoduleOrder': CurrentSubmoduleOrder,
				'ChangeOrderSubmodulesID': ChangeOrderSubmodulesID
			},
			function(data){
				data = $.parseJSON(data);
				if(data.success === true) {
					var sub = thisObj.parent().parent();
					var mod = sub.parent().parent().find('div.moduleHead');
					// get old submodule values
					var dif1 = parseInt(sub.find('div.currentControl').find('input').val());
					var dif2 = parseInt(sub.find('div.landmarkControl').find('input').val());
					
					// change module header
					var old = parseInt(mod.find('div.currentControl').html());
					mod.children('div.currentControl').html(old - dif1);

					old = parseInt(mod.find('div.landmarkControl').html());
					mod.children('div.landmarkControl').html(old - dif2);

					// change sum rate
					var RateIndicator = $('span.RateIndicator');
					old = RateIndicator.html();
					RateIndicator.html(old - dif1 - dif2);
					
					thisObj.parent().parent().remove();
					EventInspector_ShowMsg('Мероприятие удалено', 'success');
				}
				else EventInspector_ShowMsg('Ошибка при удалении мероприятия', 'error');
			}
		);
	});
	
	// Отмена удаления модулей/мероприятий
	$('.moduleList').on('click', '.cancel ', function(){
		$(this).parent().parent().children('div.actions').css('display', 'block');
		$(this).parent().remove();
	});
	
	// Поменять название модуля
	var ModuleName;
	$('div.moduleList').on('focusin', 'input.ModuleName', function(){
		ModuleName = $(this).val();
	});
	$('div.moduleList').on('focusout', 'input.ModuleName', function(){
		var thisObj = $(this);
    	$(this).attr("disabled", true);
		var NewModuleName = $(this).val();
		if (NewModuleName != '' && ModuleName != NewModuleName) {
			var ID = $(this).parent('').parent('').parent('').attr('id');
			$.post(
				URLdir + 'handler/map/ChangeModuleName',
				{
					'ModuleID': ID,
					'ModuleName': NewModuleName
				},
				function(data){
					data = $.parseJSON(data);
					if(data.success === true)
						EventInspector_ShowMsg('Имя модуля изменено', 'success');
					else EventInspector_ShowMsg('Ошибка при изменении имени модуля', 'error');
					thisObj.removeAttr('disabled');
				}
			);
		} else thisObj.removeAttr('disabled');
	});
	$('.moduleList').on('keydown', '.ModuleName', function(e){
		if(e.keyCode==13){
			$('.ModuleName').trigger('focusout');
		}
	});
	
	// Поменять название мероприятие
	var SubmoduleName;
	$('div.moduleList').on('focusin', 'input.SubmoduleName', function(){
		SubmoduleName = $(this).val();
	});
	$('div.moduleList').on('focusout', 'input.SubmoduleName', function(){
		var thisObj = $(this);
    	$(this).attr("disabled", true);
		var NewSubmoduleName = $(this).val();
		if (NewSubmoduleName != '' && SubmoduleName != NewSubmoduleName) {
			var ID = $(this).parent('div').parent('div').attr('id');
			$.post(
				URLdir + 'handler/map/ChangeSubmoduleName',
				{
					'SubmoduleID': ID,
					'SubmoduleName': NewSubmoduleName
				},
				function(data){
					data = $.parseJSON(data);
					if(data.success === true)
						EventInspector_ShowMsg('Имя мероприятия изменено', 'success');
					else EventInspector_ShowMsg('Ошибка при изменении имени мероприятия', 'error');
					thisObj.removeAttr('disabled');
				}
			);
		} else thisObj.removeAttr('disabled');
	});
	$('div.moduleList').on('keydown', 'input.SubmoduleName', function(e){
		if(e.keyCode==13){
			$('.SubmoduleName').trigger('focusout');
		}
	});
	
	// При записи в input текущий контроль
	// При фокусе
	var OldMaxRate = 0;
	$('div.moduleList').on('focusin', 'input.inputCurrentControl', function(){
		OldMaxRate = $(this).val();
	});
	// При потери фокуса
	$('div.moduleList').on('focusout', 'input.inputCurrentControl', function(){
    	$(this).attr("disabled", true);
		SetNewRateAndControl($(this), OldMaxRate);
	});
	
	// При записи в input рубежный контроль
	// При фокусе
	var OldMaxRate = 0;
	$('div.moduleList').on('focusin', 'input.inputLandmarkControl', function(){
		OldMaxRate = $(this).val();
	});
	// При потере фокуса
	$('div.moduleList').on('focusout', 'input.inputLandmarkControl', function(){
		$(this).attr("disabled", true);
		SetNewRateAndControl($(this), OldMaxRate);
	});
	
	// В inputCredit (где баллы вводить) разрешаем вводить только цифры
	$("div.moduleList").on('keydown', 'input.inputCredit', function(event) {
        KeyDownOnlyNumber(event);
    });


});
